=== debian/changelog ===
rocsolver (6.4.3-1) unstable; urgency=medium

  [ Cordell Bloor ]
  * Upload to unstable
  * Remove inactive maintainers from uploaders
  * Update my email address and copyright
  * Update for latest pkg-rocm-tools
  * d/control: update rocblas and rocprim B-D versions
  * d/rules: fix path to test binary in build tree
  * d/rules: use GPU_TARGETS rather than deprecated AMDGPU_TARGETS
  * d/rules: suppress specialization storage class warning

  [ Kentaro Hayashi ]
  * Use d/watch 5

 -- Cordell Bloor <cgmb@debian.org>  Fri, 07 Nov 2025 14:47:34 -0700

rocsolver (6.4.3-1~exp1) experimental; urgency=medium

  * New upstream version 6.4.3

 -- Christian Bayle <bayle@debian.org>  Tue, 23 Sep 2025 03:22:05 +0200

rocsolver (6.4.1-1~exp1) experimental; urgency=medium

  [ Christian Kastner ]
  * Update d/gbp.conf to reflect Team use
  * Drop patch prefix numbers
  * Update d/gbp.conf to follow DEP-14
  * New upstream version 6.4.1
  * Drop obsolete patches
  * Rebase patches
  * Update d/copyright
  * Bump Standards-Version to 4.7.2 (no changes needed)
  * Add Extend-docs-conf.py-for-offline-build.patch
  * Build documentation with python3-rocm-docs
  * Switch test runner over to universal location
  * Enable autopkgtests for arm64, ppc64el
  * Add librocprim-dev to Build-Depends
  * Bump librocblas-dev Build-Depends
  * Use rocm-target-arch to select and document build GPU arch

 -- Christian Bayle <bayle@debian.org>  Mon, 22 Sep 2025 04:33:46 -0700
