=== debian/tests/control ===
Test-Command: rocm-test-launcher /usr/libexec/rocm/librocsolver0-tests/run-tests
Features: test-name=librocsolver0-tests
Depends: pkg-rocm-tools, librocsolver0-tests, libopenblas0-pthread
Restrictions: skippable, allow-stderr
Architecture: amd64 arm64 ppc64el
