=== debian/watch ===
Version: 5

Source: https://github.com/rocm/rocsolver/tags
Matching-Pattern: (?:.*?/)?rocm-v?(\d[\d.]*)\.tar\.gz
Filenamemangle: s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%rocsolver-$1.tar.gz%
